## Documentation

- Overview
- Website
- Tutorials
- Class Index

## Classes

- _global_
- CL3D
- CL3D.AnimatedMeshSceneNode
- CL3D.Animator
- CL3D.AnimatorAnimateTexture
- CL3D.AnimatorCameraFPS
- CL3D.AnimatorCameraModelViewer
- CL3D.AnimatorCollisionResponse
- CL3D.AnimatorFlyCircle
- CL3D.AnimatorFlyStraight
- CL3D.AnimatorFollowPath
- CL3D.AnimatorOnClick
- CL3D.AnimatorOnProximity
- CL3D.AnimatorRotation
- CL3D.BillboardSceneNode
- CL3D.BoundingBoxTriangleSelector
- CL3D.Box3d
- CL3D.CameraSceneNode
- CL3D.ColorF
- CL3D.CopperCubeVariable
- CL3D.CopperLicht
- CL3D.CubeSceneNode
- CL3D.HotspotSceneNode
- CL3D.Light
- CL3D.LightSceneNode
- CL3D.Line3d
- CL3D.Material
- CL3D.Matrix4
- CL3D.Mesh
- CL3D.MeshBuffer
- CL3D.MeshSceneNode
- CL3D.MeshTriangleSelector
- CL3D.MetaTriangleSelector
- CL3D.Mobile2DInputSceneNode
- CL3D.OctTreeTriangleSelector
- CL3D.Overlay2DSceneNode
- CL3D.ParticleSystemSceneNode
- CL3D.PathSceneNode
- CL3D.Plane3d
- CL3D.Quaternion
- CL3D.Renderer
- CL3D.Scene
- CL3D.SceneNode
- CL3D.SkyBoxSceneNode
- CL3D.SoundSceneNode
- CL3D.TerrainSceneNode
- CL3D.Texture
- CL3D.TextureManager
- CL3D.Triangle3d
- CL3D.TriangleSelector
- CL3D.Vect2d
- CL3D.Vect3d
- CL3D.Vertex3D
- CL3D.WaterSurfaceSceneNode

CopperLicht API Documentation

# Class CL3D.Plane3d

3d plane class with lots of operators and methods

Class Overview
CL3D.Plane3d()
3d plane class with lots of operators and methods.

Field Summary
Field Attributes | Field Name and Description
--- | ---
| D plane distance to origin
<static> | CL3D.Plane3d.ISREL3D_BACK back plane relation, used in Plane3d.classifyPointRelation
<static> | CL3D.Plane3d.ISREL3D_FRONT front plane relation, used in Plane3d.classifyPointRelation
<static> | CL3D.Plane3d.ISREL3D_PLANAR planar plane relation, used in Plane3d.classifyPointRelation
| Normal plane normal

Method Summary
Method Attributes | Method Name and Description
--- | ---
| classifyPointRelation(point) Classifies the relation of a point to this plane.
| clone() Creates a clone of the plane
| getDistanceTo(point) Get the distance to a point.
| getIntersectionWithLine(lineVect, linePoint, outIntersection) Get an intersection with a 3d line.
| getIntersectionWithPlane(other, outLinePoint, outLineVect) Intersects this plane with another.
| getIntersectionWithPlanes(o1, o2, outPoint) Get the intersection point with two other planes if there is one.
| getMemberPoint() Gets a member point of the plane.
| isFrontFacing(lookDirection) Returns true if the plane is frontfacing to the look direction.
| normalize() normalizes the plane
| recalculateD(mpoint) Recalculates the distance from origin by applying a new member point to the plane.
| setPlane(point, nvector) Sets initial values
| setPlaneFrom3Points(point1, point2, point3) creates a plane from 3 points

Field Detail
{Number} D
plane distance to origin

<static> CL3D.Plane3d.ISREL3D_BACK
back plane relation, used in Plane3d.classifyPointRelation

<static> CL3D.Plane3d.ISREL3D_FRONT
front plane relation, used in Plane3d.classifyPointRelation

<static> CL3D.Plane3d.ISREL3D_PLANAR
planar plane relation, used in Plane3d.classifyPointRelation

{Vect3d} Normal
plane normal
Method Detail
classifyPointRelation(point)
Classifies the relation of a point to this plane.

Parameters:
point
  Point to classify its relation.

Returns:
  ISREL3D_FRONT if the point is in front of the plane, ISREL3D_BACK if the point is behind of the plane, and ISREL3D_PLANAR if the point is within the plane.

{Plane3d} clone()
Creates a clone of the plane

Returns:
  {Plane3d} the cloned plane

getDistanceTo(point)
Get the distance to a point. Note that this only works if the normal is normalized.

Parameters:
point

getIntersectionWithLine(lineVect, linePoint, outIntersection)
Get an intersection with a 3d line.

Parameters:
lineVect
  Vector of the line to intersect with.
linePoint
  Point of the line to intersect with.
outIntersection
  Place to store the intersection point, if there is one.

Returns:
  True if there was an intersection, false if there was not.

getIntersectionWithPlane(other, outLinePoint, outLineVect)
Intersects this plane with another.

Parameters:
other
  Other plane to intersect with.
outLinePoint
  Base point of intersection line.
outLineVect
  Vector of intersection.

Returns:
  True if there is a intersection, false if not.

{Boolean} getIntersectionWithPlanes(o1, o2, outPoint)
Get the intersection point with two other planes if there is one.

Parameters:
o1
o2
outPoint

Returns:
  {Boolean} true if intersection found, false if not

getMemberPoint()
Gets a member point of the plane.

isFrontFacing(lookDirection)
Returns true if the plane is frontfacing to the look direction.

Parameters:
lookDirection
  {CL3D.Vect3d} look direction

normalize()
normalizes the plane

recalculateD(mpoint)
Recalculates the distance from origin by applying a new member point to the plane.

Parameters:
mpoint

setPlane(point, nvector)
Sets initial values

Parameters:
point
nvector

setPlaneFrom3Points(point1, point2, point3)
creates a plane from 3 points

Parameters:
point1
point2
point3

© 2011-2018 N.Gebhardt, Ambiera
Documentation generated by JsDoc Toolkit